<?php
/*
 * @component jOpenSim
 * @copyright Copyright (C) 2019 FoTo50 http://www.jopensim.com/
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');


class opensimViewinterface extends JViewLegacy {

	public function display($tpl = null) {
		$model	= $this->getModel();

		$this->input = file_get_contents("php://input");
		$this->debuglog($this->input,"Joomla php://input");
		$this->xmlrpcfunctions = $model->xmlrpcfunctions;

		$profilefunctions	= $this->xmlrpcfunctions['profilefunctions'];
		$groupfunctions		= $this->xmlrpcfunctions['groupfunctions'];
		$searchfunctions	= $this->xmlrpcfunctions['searchfunctions'];

		$jinput	= JFactory::getApplication()->input;
		$this->test = $test	= $jinput->get('test',null,'STR');

		if($test) { // this is testing mode for output in html
			if(in_array($test,$profilefunctions)) {
				$this->functionblock = "profile";
				$params = $_REQUEST;
				unset($params['test']);
				$this->retval = $model->$test($params);
			} elseif(in_array($test,$groupfunctions)) {
				$this->functionblock = "groups";
				$params = $_REQUEST;
				unset($params['test']);
//				$function	= substr($method,7); // remove "groups." from method name
				$this->retval = $model->$test($params);
			} elseif(in_array($test,$searchfunctions)) {
				$this->functionblock = "search";
				$params = $_REQUEST;
				unset($params['test']);
				$this->retval = $model->$test($params);
			} else {
				$this->functionblock = "functionblock not found :(<br />";
			}
			parent::display($tpl);

		} else { // a real xmlrpc request, dont output in html, but return valid xml response
			// todo: here the $opensim->checkRegionIP() to implement
			// todo: as well as the new support key system

			// todo: before xmlrpc request handling: terminal handling
			// todo: before xmlrpc request handling: offline messages (checking if they still send the method only in $_SERVER["PATH_INFO"])

			$request	= $model->opensim->parseXmlRpc($this->input);
			$method		= $request['method'];
			$params		= $request['decode'][0];

			if(in_array($method,$profilefunctions) || in_array($method,$groupfunctions) || in_array($method,$searchfunctions)) {
				$this->retval = $model->$method($params);
				$response = xmlrpc_encode($this->retval);
				echo $response;
				exit; // no further output ... stop here
			}
		}


		

	}

	public function debuglog($data,$title) {
		if(!$title) $zeit = "\n\n########## ".date("d.m.Y H:i:s")." ##########\n";
		else $zeit = "\n\n########## ".date("d.m.Y H:i:s")." ##### ".$title." ##########\n";
		$zeile = var_export($data,TRUE);
		$logfile = "/home/jopensim3/public_html/test/components/com_opensim/interface.log";
		$handle = fopen($logfile,"a+");
		$logzeile = $zeit.$zeile."\n\n";
		fputs($handle,$logzeile);
		fclose($handle);
		
	}
}
?>